/*!************************************************************************************************
  @file NedFile.h

  @copyright  Copyright 2021 Drew Gislason

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
  associated documentation files (the "Software"), to deal in the Software without restriction,
  including without limitation the rights to use, copy, modify, merge, publish, distribute,
  sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or
  substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
  NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  @defgroup ned_file Ned File - An API for a that describes each file in the editor.

  A file consists of a variety of points (cursor, select cursor), a buffer to contain the text,
  the full pathname, the cursor row and column, the top line of the editor window for this file.

  The NedFIle module does not display anything. That is up to the editor.

*///***********************************************************************************************
#ifndef NED_FILE_H
#define NED_FILE_H

#include <stdio.h>
#include <limits.h>
#include <time.h>
#include "Ned.h"
#include "NedLog.h"
#include "NedBuffer.h"
#include "NedMem.h"
#include "NedPoint.h"
#include "NedUtilFile.h"
#include "NedUtilStr.h"

#define NEDFILE_SANCHK    11111

// file structure as needed by the editor
typedef struct sNedFile
{
  unsigned              sanchk;         // sanity check: is this of type sNedFile_t?
  struct sNedFile      *pNext;          // next file in linked list
  sNedBuffer_t         *pBufHead;       // file contents in buffers
  sNedFileInfo_t        sInfo;          // includes full path/filename, fIsExtModified, modTime, see NedUtilFile.c
  bool_t                fSaveAs;        // autogenerated name (e.g. untitled), so save-as on save
  bool_t                fDirty;         // file is changed
  bool_t                fRdOnly;        // file is read only
  bool_t                fIsBinary;      // file is binary (cannot be edited)
  bool_t                fCrLf;          // affects NedFileSave()
  bool_t                fHardTabs;      // use hard tabs '\t'
  unsigned              tabSize;        // see NEDCFG_TAB_DEFAULT
  long                  wrapLen;        // wrap length for this file
  bool_t                fInSelect;      // in select mode
  long                  topLine;        // 1-n, line at top of screen
  long                  curLine;        // 1-n, cursor line in file
  long                  curCol;         // 1-n, cursor column in file
  long                  leftCol;        // 1-n, if line is long, screen may have scrolled to left
  long                  prefCol;        // 1-n, preferred column (e.g. up/down arrows stay on column)
  sNedPoint_t           sCursor;        // cursor
  sNedPoint_t           sSelect;        // other point for select, may be before or after cursor
} sNedFile_t;

sNedFile_t   *NedFileNew          (sNedFile_t *pFileList, const char *szPath);
sNedFile_t   *NedFileFree         (sNedFile_t *pFileList, sNedFile_t *pFile);
sNedFile_t   *NedFileInList       (const sNedFile_t *pFileList, const char *szPath);
void          NedFileFreeAll      (sNedFile_t *pFileList);
bool_t        NedFileIsFile       (const sNedFile_t *pFile);
const char   *NedFileNameOnly     (const sNedFile_t *pFile);
const char   *NedFileGetNameEx    (const sNedFile_t *pFile, unsigned dirLevel);
const char   *NedFileNameNoDup    (sNedFile_t *pFileList, sNedFile_t *pFile);
unsigned      NedFileCount        (const sNedFile_t *pFileList);
sNedFile_t   *NedFileSelect       (unsigned index);
unsigned      NedFileIndex        (const sNedFile_t *pFileList, const sNedPoint_t *pPoint);
sNedFile_t   *NedFileNext         (const sNedFile_t *pFile);
sNedFile_t   *NedFilePrev         (const sNedFile_t *pFileList, const sNedFile_t *pFile);
char         *NedFilePath         (const sNedFile_t *pFile);
void          NedFilePathRename   (sNedFile_t *pFile, const char *szNewPath);
sNedBuffer_t *NedFileBuf          (const sNedFile_t *pFile);
bool_t        NedFileLoad         (sNedFile_t *pFile);
bool_t        NedFileSave         (sNedFile_t *pFile);
void          NedFileClear        (sNedFile_t *pFile);
bool_t        NedFileIsBinary     (const sNedFile_t *pFile);
unsigned      NedFileUniqueId     (const sNedFile_t *pFileList);
long          NedFileSize         (const sNedFile_t *pFile);
const char   *NedFileUniqueName   (const sNedFile_t *pFileList, const char *szExt);
long          NedFileColGet       (const sNedFile_t *pFile, const sNedPoint_t *pPoint);
long          NedFileColSet       (sNedFile_t *pFile, sNedPoint_t *pPoint, long prefCol);
long          NedFileLineGet      (const sNedFile_t *pFile, const sNedPoint_t *pPoint, long *pCol);
long          NedFileLineSet      (sNedFile_t *pFile, const sNedPoint_t *pPoint, long prefCol);

void          NedFileLogShow      (sNedFile_t *pFile, logDetail_t detail);

#endif // NED_FILE_H
